unit NDamen99; { SCHNELLE_N_DAMEN  Algorithmus : 4 Linienberwachung }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Grids, ExtCtrls, DBCtrls;

type
  TNDamen = class(TForm)
    NAnzahl: TSpinEdit;
    StaticText1: TStaticText;
    Start: TButton;
    StaticTextN: TStaticText;
    LabelN: TLabel;
    StaticTextTime: TStaticText;
    LabelZeit: TLabel;
    CheckAusgabe: TCheckBox;
    Ausgabe: TListBox;
    Art: TRadioGroup;
    procedure StartClick(Sender: TObject);
    procedure Iterativ;
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var NDamen: TNDamen;

implementation

{$R *.DFM}
{$R-,Q-}
 CONST MAXN=20; LMax=10000;
 VAR M,N:Byte;
     Anzahl:Integer;
     HORIZONTAL:ARRAY[1..MAXN]OF Byte;
     SPALTE:ARRAY[1..MAXN]OF Byte;
     FALLEND:ARRAY[1..2*MAXN]OF Byte;
     STEIGEND:ARRAY[1..2*MAXN]OF Byte;
     T_Sek:Extended;
     Taste:Char;
     Liste:Array[1..LMax]of Char;

 function TimeSekunden:Extended;
  var H, M, S, MS : Word;
  begin
   DecodeTime(Now,H,M,S,MS);
   TimeSekunden:=3600.0*H+60.0*M+S+MS/1000
  end;

 procedure TNDamen.Iterativ;
  var I,X,Y,M:Byte;
      Zeile:String;
  begin
   X:=NAnzahl.Value;M:=X+1;Y:=M;
   REPEAT
   REPEAT
    REPEAT
     DEC(Y);
    UNTIL (Y=0) OR ((HORIZONTAL[Y]=0) AND (FALLEND[X+Y]=0) AND (STEIGEND[Y-X+M]=0));
    IF Y>0 THEN
     BEGIN
      HORIZONTAL[Y]:=Y;
      SPALTE[X]:=Y;FALLEND[X+Y]:=Y;
      STEIGEND[Y-X+M]:=Y;DEC(X);Y:=M
     END
   UNTIL (X=0) OR (Y=0);
   IF Y>0 THEN
    BEGIN
     INC(Anzahl);
     IF TASTE='J' THEN
      begin
       Zeile:='';
       FOR I:=1 TO N DO
        Zeile:=Zeile+CHAR(64+I)+IntToStr(SPALTE[I])+Char(32);
       Ausgabe.Items.Add(Zeile);
      end
    END;
   INC(X);
   IF X<M THEN
    BEGIN
     Y:=SPALTE[X];HORIZONTAL[Y]:=0;FALLEND[X+Y]:=0;
     STEIGEND[Y-X+M]:=0
    END
   UNTIL X=M;
  end;

 PROCEDURE SETZEN;
  BEGIN
   ASM
           PushAD                            // alle Register auf den Stapel
           Mov EBP, Offset Steigend          // Startadresse von Steigend
           Mov ESI, Offset Fallend           // Startadresse von Fallend
           Mov ECX, Offset Spalte            // Startadresse von Spalte
           Mov EDI, Offset Horizontal        // Startadresse von Horizontal
           Dec EBP                           // Startadresse-1
           Dec ESI                           // Startadresse-1
           Dec ECX                           // Startadresse-1
           Dec EDI                           // Startadresse-1
           Mov AL,M                          // AL:=M  Y konstant
           Mov AH,N                          // AH:=N  X konstant
           Mov BL,AH                         // BL:=N  X variabel
           Mov BH,AL                         // BH:=M  Y variabel
           Xor EDX,EDX                       // EDX:=0
   @Start: Dec BH                            // Y:=Y-1
//           Jz @Unten                         // Y=0 ==> springe zu Label Unten
           Mov DL,BH                         // DL:=BH, Indexregister
           Cmp [EDI+EDX],DH                  // HO[Y]>0?
           Jg @Start                         // falls ja, zu Label Start

           // hier fehlt was!!!

   @Ende:  PopAD                             // alle Register vom Stapel
   END
  END;

 procedure TNDamen.StartClick(Sender: TObject);
  var TimeStr,Teil:String;
      I:Integer;
  begin
   N:=StrToInt(NAnzahl.Text);Taste:='N';
   if CheckAusgabe.Checked and (N<10) then Taste:='J'
   else CheckAusgabe.Checked:=False;
   FOR I:=1 TO MAXN DO BEGIN HORIZONTAL[I]:=0;SPALTE[I]:=0 END;
   FOR I:=1 TO 2*MAXN DO BEGIN FALLEND[I]:=0;STEIGEND[I]:=0 END;
   M:=N+1;Anzahl:=0;FillChar(Liste,SizeOf(Liste),'@');
   Screen.Cursor:=crHourGlass;Ausgabe.Items.Clear;
   T_Sek:=TimeSEKUNDEN;
   if Art.ItemIndex=0 then SETZEN else Iterativ;
   T_Sek:=TimeSEKUNDEN-T_Sek;
   Screen.Cursor:=crDefault;
   Str(T_Sek:0:2,TimeStr);
   LabelZeit.Caption:=TimeStr+' sek.';
   LabelN.Caption:=IntToStr(Anzahl);
   if Art.ItemIndex=0 then
    begin
     Teil:='';
     if Taste='J' then
      for I:=1 to LMax do
       if Liste[I]<>'@' then Teil:=Teil+Liste[I]
       else begin
             if Teil='' then break;
             Ausgabe.Items.Add(Teil);Teil:=''
            end
    end
  end;

end.


